Subject: Re: bug#61413: [PATCH] Make warnings show a "warning" emoji instead of a stop-sign

From: Kévin Le Gouguec <[email-masked]>
Date: Tue, 11 Mar 2025 22:24:23 +0100

Konstantin Kharlamov <[email-masked]> writes:

>> > > <https://debbugs.gnu.org/cgi/bugreport.cgi?bug=61413#108>
>> > > 
>> > > Screenshot:
>> > > 
>> > > <https://debbugs.gnu.org/cgi/bugreport.cgi?att=2;bug=61413;filename=Screenshot_20250223_163540.png;msg=108>
>> > 
>> > Looks nice! FTR, I'm looking at screenshot, and I think maybe it's
>> > worth clarifying what I mean while saying making the icon a button. I
>> > meant the visual appearance of a button, like the ones you can see in
>> > customization menu for variables. Let me put it another way: if you
>> > take your screenshot to a user who knows nothing about this buffer and
>> > ask them "find all buttons on the screenshot" — do you think they'd
>> > point at the warning sign and say "…and these are obviously buttons
>> > too"? I bet they would not.
>> 
>> I should have clarified: this patch does *three* things:
>> 
>> 1. it adds the "(suppress)" text button,
>> 2. it swaps the no-entry sign with a warning sign,
>> 3. (!) it un-buttonizes the warning sign.
>> 
>> IOW with that patch, the warning signs _are_ purely decorative; the
>> text
>> buttons really _are_ the only actionable buttons in that screenshot.
>> 
>> ISTM if we go for both 1 & 2 (which both had support among participants,
>> AFAIR), then 3 is a logical next step: why overload the warning sign
>> with a suppression function, when there is a perfectly explicit text
>> button for that?
>
> Oh, I see. Well, good idea, but why does (suppress) text on your
> screenshot looks like a link and not a button then?

The patch uses the 'buttonize' function, which applies the 'button'
face; which indeed by default looks like a link:

  (defface button '((t :inherit link))
    "Default face used for buttons."
    :group 'basic-faces)

So even though it looks like a link, "(suppress)" should look consistent
with other "clickable things" in Emacs.

As you noticed though, the Custom menus use a different face for their
"clickable things" - 'custom-button', which looks less like a link and
more like regular "boxed gray-background push-buttons".

ISTM using the "regular" 'button' face is better for consistency, unless
we have strong reasons to deviate; I'd rather let users & themes opt in
to aligning 'button' with 'custom-button' if they want (I do that FWIW)
instead of shunning the "canonical" button face because it doesn't look
"buttony enough" by default.